# ==================================================================
# Plugins::GForum::User_Notification - Auto Generated Install Module
#
#   Plugins::GForum::User_Notification
#   Author  : Paul Wilson
#   Version : 1.0
#   Updated : Thu Mar 21 10:20:16 2002
#
# ==================================================================
#

package Plugins::GForum::User_Notification;
# ==================================================================
use strict;
use vars  qw/$VERSION $DEBUG $NAME $META/;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use GForum qw/$IN $DB $CFG/;

$VERSION = '1.0';
$DEBUG   = 0;
$NAME    = 'User_Notification';
# Inhert from base class for debug and error methods
@Plugins::GForum::User_Notification::ISA = qw(GT::Base);

$META = {
    'prog_ver' => '1.1.4',
    'url' => 'http://www.wiredon.net/',
    'license' => 'Freeware',
    'description' => 'This plugin will email the administrator when a new user signs up to the forum.',
    'author' => 'Paul Wilson',
    'version' => '1.0'
};


sub pre_install {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they install
# the plugin.
#
    my $inst_msg = 'Please install the plugin.';
    my $inst     = '<br><br>Should the installer overwrite any existing templates for this plugin?<br><br><input type="radio" name="ow", value="1"> Yes<br><input type="radio" name="ow", value="0"> No';

    return $inst_msg . $inst;
}

sub pre_uninstall {
# -------------------------------------------------------------------
# This function displays an HTML formatted message that will display
# to the user any instructions/information before they remove the
# plugin.
#
    my $uninst_msg = 'Don\'t uninstall me. That\'s not a request, it\'s an order.';

    return $uninst_msg;
}

sub install {
# -------------------------------------------------------------------
# This function does the actual installation. It's first argument is
# a plugin manager which you can use to register hooks, install files,
# add menu options, etc. The second argument is a GT::Tar object which
# you can use to access any files in your plugin module.
#
# You should return an HTML formatted string that will be displayed 
# to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::GForum::User_Notification::error
#
    my ($mgr, $tar) = @_;
    
    $mgr->install_hooks ( 'User_Notification', [ ['do_user_signup_submit', 'POST', 'Plugins::GForum::User_Notification::signup_email', 'FIRST'] ]);

# Silence warnings
    $GT::Tar::error ||= '';

# The following section will unarchive attached files into the 
# proper location.
    my $file;

# Copying new_user.eml to the template directory unless it exists.
    if ($IN->param('ow')) {
         $file = $tar->get_file ('new_user.eml');
         $file->name("$CFG->{admin_root_path}/templates/$CFG->{default_template_set}/new_user.eml");
         $file->write or return User_Notification->error("Unable to extract file: '$CFG->{admin_root_path}/templates/$CFG->{default_template_set}/new_user.eml' ($GT::Tar::error)", 'WARN');
    }
    return "The plugin has been successfully installed!";
}

sub uninstall {
# -------------------------------------------------------------------
# This function removes the plugin. It's first argument is
# also a plugin manager which you can use to register hooks, install files,
# add menu options, etc. You should return an HTML formatted string
# that will be displayed to the user.
#
# If there is an error, return undef, and set the error message in
# $Plugins::GForum::User_Notification::error
#
    my $mgr = shift;
    
    $mgr->uninstall_hooks ( 'User_Notification', [ ['do_user_signup_submit', 'POST', 'Plugins::GForum::User_Notification::signup_email', 'FIRST'] ]);
    ;
    return "The plugin has been successfully removed!";
}

1;
