# ==================================================================
# Plugins::GForum::User_Notification - Auto Generated Program Module
#
#   Plugins::GForum::User_Notification
#   Author  : Paul Wilson
#   Version : 1.0
#   Updated : Thu Mar 21 10:20:16 2002
#
# ==================================================================
#

package Plugins::GForum::User_Notification;
# ==================================================================

use strict;
use GT::Base;
use GT::Plugins qw/STOP CONTINUE/;
use GForum qw/$IN $DB $CFG/;

# Inherit from base class for debug and error methods
@Plugins::GForum::User_Notification::ISA = qw(GT::Base);


# PLUGIN HOOKS
# ===================================================================

sub signup_email {
# -------------------------------------------------------------------
# Send an email to the administrator when a new user signs up.

# If there was a registration error there are no args.
    return unless @_;

    send_email('new_user.eml', $_[1]);

    return @_;
}

sub send_email {
#--------------------------------------------------------------------
# Send the actual email using the user_signup.eml template.

    my ($template, $vars) = @_;

    require GT::Mail::Editor;
    require GT::Mail;

    my $email = GT::Mail::Editor->new(dir => "$CFG->{admin_root_path}/templates", template => ($vars->{user_template} || $CFG->{default_template_set}));
    $email->load($template);
    my $headers = $email->headers;
    my %head;
    while (my ($k, $v) = each %$headers) {
        my $val = $v; # Copy it
        $val = GForum::Template->parse("string", $vars, { string => $val });
        $head{$k} = $val;
    }
    $head{To}   ||= $CFG->{admin_email};
    $head{From} ||= $CFG->{admin_email};
    my $body = $email->body;
    $body = GForum::Template->parse("string", $vars, { string => $body });
    $CFG->{smtp_server} or $CFG->{mail_path} or die 'No mail path or SMTP server set!';
    my $mailer = GT::Mail->new(
        %head,
        msg  => $body,
        ($CFG->{smtp_server} ? (smtp => $CFG->{smtp_server}) : (sendmail => $CFG->{mail_path}))
    );
    $mailer->send or return "Unable to send mail: " . $mailer->error;
    0;
}

# Always end with a 1.
1;
